#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include "stddef.c"
#define WIN32_LEAN_AND_MEAN
#define NOMINMAX
#include <windows.h>
#include "MMFile.cpp"
#include "CQXDoc.cpp"
#include "DumpQXDoc.cpp"
#include "FrameGeom.cpp"

int main(int argc, char *argv[])
{
	// Open a new database file
	if (!mmfile.Open("tmp/studybible.dat", 400000000))
		return 0;


	// Retrieve root object
	CDatabase *database = (CDatabase*)mmfile.FirstObject();

	FOREACH_IN_LIST(CBook, book, database->all_books)
	{
		char fn[200];
		sprintf(fn, "dumpb/%s.html", book->name.A());
		FILE *fout = fopen(fn, "wt");
		if (fout)
		{
			FOREACH_IN_LIST_N(CFrame, frame, 
			                  book->first_frame_reading_order, next_reading_order)
			{
				fprintf(fout, "<FONT COLOR=\"904090\">");
				switch(frame->geom_type)
				{	case gt_col1 : fprintf(fout, "Kolom 1: "); break;
					case gt_col2 : fprintf(fout, "Kolom 2: "); break;
					case gt_col3 : fprintf(fout, "Kolom 3: "); break;
					case gt_col4 : fprintf(fout, "Kolom 4: "); break;
					case gt_col1_vn : fprintf(fout, "Versnummer in kolom 1: "); break;
					case gt_col2_vn : fprintf(fout, "Versnummer in kolom 2: "); break;
					case gt_col3_vn : fprintf(fout, "Versnummer in kolom 3: "); break;
					case gt_col4_vn : fprintf(fout, "Versnummer in kolom 4: "); break;
					case gt_peri_title: fprintf(fout, "Pericoop titel: "); break;
					case gt_normal : fprintf(fout, "Normaal: "); break;
					default : fprintf(fout, "Anders: "); break;
				}
				fprintf(fout, "</FONT>");
				dump_text_fragment_to_HTML(frame->text_fragment.A(), fout);
				fprintf(fout, "<BR>");
			}
					
			fclose(fout);
		}
	}

	mmfile.Close();

	
	return 0;
}
