
char *temp_char1000_buf()
{
	static char buf[10][100];
	static int i = 0;
	
	i = (i+1) % 10;
	return buf[i];
}

// ---- Greek characters -------------

#define ALPHA		1
#define BETA		2
#define GAMMA		3
#define DELTA		4
#define EPSILON		5
#define ZETA		6
#define ETA			7
#define THETA		8
#define IOTA		9
#define KAPPA		10
#define LAMBDA		11	
#define MU			12
#define NU			13
#define XI			14
#define OMICRON		15
#define PI			16
#define RHO			17
#define SIGMA		18
#define TAU			19
#define UPSILON		20
#define PHI			21
#define CHI			22
#define PSI			23
#define OMEGA		24
#define LOW_I_PRE	25
#define CAP      (1<<6)
#define ACUTE    (1<<7)
#define GRAVE    (1<<8)
#define UML		 (1<<9)
#define TILDE    (1<<10)
#define ASP      (1<<11)
#define NASP     (1<<12)

#define GREEKCHAR(X)   ((X)&(31))
#define GREEKCAP(X)    ((X)&(CAP))
#define GREEKCHARCAP(X) ((X)&(31|CAP))
#define GREEKSTRESS(X) ((X)&(ACUTE|GRAVE))
#define GREEKTILDE(X)    ((X)&(TILDE))
#define GREEKACC(X)    ((X)&(UML|TILDE))
#define GREEKASP(X)    ((X)&(ASP|NASP))
#define GREEKNOASP(X)  ((X)&~(ASP|NASP))
#define GREEKCHARSTRESS(X) ((X)&(31|ACUTE|GRAVE))


#define NR_GREEK_CHAR  152
struct 
{	char ch;
	long gcc;
} greek_encoding[NR_GREEK_CHAR] = {
	{ 0x27,			 NASP							},
	{ 0x41,	ALPHA				|CAP				},
	{ 0x42,	BETA				|CAP				},
	{ 0x44,	IOTA	|NASP	|GRAVE					},
	{ 0x45,	EPSILON				|CAP				},
	{ 0x46,								LOW_I_PRE	},
	{ 0x47,	UPSILON	|NASP	|ACUTE					},
	{ 0x48,	ETA					|CAP				},
	{ 0x49,	IOTA				|CAP				},
	{ 0x4A,	OMEGA	|NASP	|GRAVE					},
	{ 0x4B,	KAPPA				|CAP				},
	{ 0x4C,	ALPHA	|ASP	|GRAVE					},
	{ 0x4D,	MU					|CAP				},
	{ 0x4E,	NU					|CAP				},
	{ 0x4F,	OMICRON				|CAP				},
	{ 0x50,	RHO					|CAP				},
	{ 0x51,	IOTA	|ASP	|GRAVE					},
	{ 0x52,	UPSILON	|ASP	|GRAVE					},
	{ 0x53,	OMEGA	|ASP	|GRAVE					},
	{ 0x54,	TAU					|CAP				},
	{ 0x55,	IOTA				|UML|GRAVE			},
	{ 0x56,	UPSILON				|UML|GRAVE			},
	{ 0x58,	CHI					|CAP				},
	{ 0x59,	UPSILON				|CAP				},
	{ 0x5A,	ZETA				|CAP				},
	{ 0x5C,			 NASP							},
	{ 0x5E,			 ASP							},
	{ 0x61,	ALPHA			|GRAVE					},
	{ 0x62,	EPSILON			|GRAVE					},
	{ 0x63,	ETA				|GRAVE					},
	{ 0x64,	IOTA			|GRAVE					},
	{ 0x65,	OMICRON			|GRAVE					},
	{ 0x66,	UPSILON			|GRAVE					},
	{ 0x67,	OMEGA			|GRAVE					},
	{ 0x69,	ALPHA	|NASP	|GRAVE					},
	{ 0x6A,	ETA		|NASP	|GRAVE					},
	{ 0x6B,	OMICRON	|NASP	|GRAVE					},
	{ 0x6D,	ETA		|ASP	|GRAVE					},
	{ 0x6E,	OMICRON	|ASP	|GRAVE					},
	{ 0x6F,	OMICRON	|ASP	|GRAVE					},
	{ 0x70,	ALPHA	|NASP	|TILDE					},
	{ 0x71,	ETA		|NASP	|TILDE					},
	{ 0x72,	IOTA	|NASP	|TILDE					},
	{ 0x73,	UPSILON	|NASP	|TILDE					},
	{ 0x74,	OMEGA	|NASP	|TILDE					},
	{ 0x77,	ETA		|ASP	|TILDE					},
	{ 0x78,	IOTA	|ASP	|TILDE					},
	{ 0x79,	UPSILON	|ASP	|TILDE					},
	{ 0x7A,	OMEGA	|ASP	|TILDE					},
	{ 0x80,	ALPHA			|TILDE					},
	{ 0x83,	ETA				|TILDE					},
	{ 0x84,	ETA										},
	{ 0x85,	IOTA			|TILDE					},
	{ 0x86,	UPSILON			|TILDE					},
	{ 0x87,	OMEGA			|TILDE					},
	{ 0x88,	ALPHA	|NASP							},
	{ 0x89,	EPSILON	|NASP							},
	{ 0x8A,	ETA		|NASP							},
	{ 0x8B,					 ACUTE					},
	{ 0x8C,	IOTA	|NASP							},
	{ 0x8D,	OMICRON	|NASP							},
	{ 0x8E,	UPSILON	|NASP							},
	{ 0x8F,	OMEGA	|NASP							},
	{ 0x90,	ALPHA	|ASP							},
	{ 0x91,	EPSILON	|ASP							},
	{ 0x92,	EPSILON	|ASP	|GRAVE					},
	{ 0x93,	ETA		|ASP							},
	{ 0x94,	IOTA	|ASP							},
	{ 0x95,	OMICRON	|ASP							},
	{ 0x96,	UPSILON	|ASP							},
	{ 0x97,	OMEGA	|ASP							},
	{ 0x98,			 NASP	|ACUTE					},
	{ 0x99,	ALPHA	|NASP	|ACUTE					},
	{ 0x9A,	EPSILON	|NASP	|ACUTE					},
	{ 0x9B,	ETA		|NASP	|ACUTE					},
	{ 0x9C,	IOTA	|NASP	|ACUTE					},
	{ 0x9D,	OMICRON	|NASP	|ACUTE					},
	{ 0x9E,	UPSILON	|NASP	|ACUTE					},
	{ 0x9F,	OMEGA	|NASP	|ACUTE					},
	{ 0xA1,	GAMMA				|CAP				},
	{ 0xA2,	DELTA				|CAP				},
	{ 0xA3,	THETA				|CAP				},
	{ 0xA4,	LAMBDA				|CAP				},
	{ 0xA5,	CHI					|CAP				},
	{ 0xA6,	PI					|CAP				},
	{ 0xA8,	RHO		|ASP							},
	{ 0xA9,	THETA									},
	{ 0xAA,	SIGMA				|CAP				},
	{ 0xAD,			 ASP	|ACUTE					},
	{ 0xB0,	ALPHA				|CAP				},
	{ 0xB1,	ALPHA	|ASP	|ACUTE					},
	{ 0xB2,	EPSILON	|ASP	|ACUTE					},
	{ 0xB3,	ETA		|ASP	|ACUTE					},
	{ 0xB4,	IOTA	|ASP	|ACUTE					},
	{ 0xB5,	BETA				|CAP				},
	{ 0xB6,	EPSILON				|CAP				},
	{ 0xB7,	ZETA				|CAP				},
	{ 0xB8,	ETA					|CAP				},
	{ 0xB9,	IOTA				|CAP				},
	{ 0xBA,	KAPPA				|CAP				},
	{ 0xBB,	MU					|CAP				},
	{ 0xBC,	PHI					|CAP				},
	{ 0xBE, PSI					|CAP				},
	{ 0xBF,	OMEGA				|CAP				},
	{ 0xC0,	ALPHA			|ACUTE					},
	{ 0xC1,	NU					|CAP				},
	{ 0xC2,	OMICRON	|ASP	|GRAVE					},
	{ 0xC3, OMICRON				|CAP				},
	{ 0xC4,	PI					|CAP				},
	{ 0xC5,	UPSILON	|ASP	|ACUTE					},
	{ 0xC6,	TAU					|CAP				},
	{ 0xCC,	CHI					|CAP				},
	{ 0xCF,	OMEGA	|ASP	|ACUTE					},
	{ 0xD5,			 NASP							},
	{ 0xD6,								LOW_I_PRE	},
	{ 0xD8,	IOTA	|NASP		|CAP				},
	{ 0xDB,	EPSILON			|ACUTE					},
	{ 0xDC,	ETA				|ACUTE					},
	{ 0xDD,	IOTA			|ACUTE					},
	{ 0xDE,	OMICRON			|ACUTE					},
	{ 0xE0,	UPSILON			|ACUTE					},
	{ 0xE1,	ALPHA									},
	{ 0xE2,	BETA									},
	{ 0xE3,	PSI										},
	{ 0xE4,	DELTA									},
	{ 0xE5,	EPSILON									},
	{ 0xE6,	PHI										},
	{ 0xE7,	GAMMA									},
	{ 0xE8,	ETA										},
	{ 0xE9,	IOTA									},
	{ 0xEA,	XI										},
	{ 0xEB,	KAPPA									},
	{ 0xEC,	LAMBDA									},
	{ 0xED,	MU										},
	{ 0xEE,	NU										},
	{ 0xEF,	OMICRON									},
	{ 0xF0,	PI										},
	{ 0xF1,	OMEGA			|GRAVE					},
	{ 0xF2,	RHO										},
	{ 0xF3,	SIGMA									},
	{ 0xF4,	TAU										},
	{ 0xF5,	THETA									},
	{ 0xF6,	OMEGA									},
	{ 0xF7,	SIGMA									},
	{ 0xF8,	CHI										},
	{ 0xF9,	UPSILON									},
	{ 0xFA,	ZETA									},
	{ 0xFB,	IOTA				|UML				},
	{ 0xFC,	UPSILON				|UML				},
	{ 0xFD,	IOTA				|UML|ACUTE			},
	{ 0xFE,	UPSILON				|UML|ACUTE			},
	{ 0xFF,								LOW_I_PRE	},
};

long ch_to_gcc[256];
char gcc_to_ch[8192];

bool do_init_greek = true;
void init_greek()
{	
	int i;
	for (i = 0; i < 256; i++)
		ch_to_gcc[i] = 0;
	for (i = 0; i < 8192; i++)
		gcc_to_ch[i] = '\0';
		
	for (i = NR_GREEK_CHAR; i >= 0; i--)
	{	ch_to_gcc[(const unsigned char)greek_encoding[i].ch] = greek_encoding[i].gcc;
		gcc_to_ch[(word)greek_encoding[i].gcc] = greek_encoding[i].ch;
	}

	do_init_greek = false;
}

inline long greek_char_code(const char ch)
// Returns the logical representation of the given Greek character
{
	return ch_to_gcc[(const unsigned char)ch];
}

bool for_dump = false;

char *greek_to_text(const char *greek_word)
// Returns a printable string for the given Greek string
{
	if (do_init_greek) init_greek();

	char *buf = temp_char1000_buf();
	char *s = buf;
	bool first_greek = true;
	bool prev_is_low_i = false;
	
	for (const byte *ch = (const byte*)greek_word; *ch != '\0'; ch++)
	{
		long gcc = greek_char_code(*ch);
		if (gcc == 0)
		{
			if (*ch == ';')
				*s++ = '?';
			else if (   *ch == ' '
					 || *ch == '!' 
					 || *ch == '('
					 || *ch == ')'
					 || *ch == '*'
					 || *ch == '+'
					 || *ch == ','
					 || *ch == '-'
					 || *ch == '.'
					 || ('1' <= *ch && *ch <= '9')
					 || *ch == '?' 
					 || *ch == '[' 
					 || *ch == ']')
				*s++ = *ch;
			else if (*ch == 0x81)
				*s++ = '1';
			else if (*ch == 0x82)
				*s++ = '2';
			else if (*ch == 0x84 && ch == (const byte*)greek_word && for_dump)
				*s++ = '3';
			else if (*ch == 0xAF)
				*s++ = ';';  // high period, transliterated as ; : or ,
			else if (*ch == 0xCA)
				*s++ = ' ';
			else
			{	sprintf(s, "#%02X", *ch);
				s += 3;
			}
		}
		else
		{
			if (gcc & TILDE)
				*s++ = '~';
			
			if (gcc & NASP)
			{	if (gcc == NASP && !first_greek)
					*s++ = '|';
				else
					*s++ = '\'';
			}
			if (gcc & ASP)
				*s++ = 'h';
			
			if (gcc & UML)
				*s++ = '"';
			if (gcc & GRAVE)
				*s++ = '\\';
			if (gcc & ACUTE)
				*s++ = '/';
			
			switch(GREEKCHARCAP(gcc))
			{	case ALPHA|CAP:		*s++ = 'A'; break;
				case BETA|CAP:		*s++ = 'B'; break;
				case GAMMA|CAP:		*s++ = 'G'; break;
				case DELTA|CAP:		*s++ = 'D'; break;
				case EPSILON|CAP:	*s++ = 'E'; break;
				case ZETA|CAP:		*s++ = 'Z'; break;
				case ETA|CAP:		*s++ = 'E'; *s++ = '^'; break;
				case THETA|CAP:		*s++ = 'T'; *s++ = 'h'; break;
				case IOTA|CAP:		*s++ = 'I'; break;
				case KAPPA|CAP:		*s++ = 'K'; break;
				case LAMBDA|CAP:	*s++ = 'L'; break;
				case MU|CAP:		*s++ = 'M'; break;
				case NU|CAP:		*s++ = 'N'; break;
				case XI|CAP:		*s++ = 'X'; break;
				case OMICRON|CAP:	*s++ = 'O'; break;
				case PI|CAP:		*s++ = 'P'; break;
				case RHO|CAP:		*s++ = 'R'; break;
				case SIGMA|CAP:		*s++ = 'S'; break;
				case TAU|CAP:		*s++ = 'T'; break;
				case UPSILON|CAP:	*s++ = 'Y'; break;
				case PHI|CAP:		*s++ = 'P'; *s++ = 'h'; break;
				case CHI|CAP:		*s++ = 'C'; *s++ = 'h'; break;
				case PSI|CAP:		*s++ = 'P'; *s++ = 's'; break;
				case OMEGA|CAP:		*s++ = 'O'; *s++ = '^'; break;
				case ALPHA:			*s++ = 'a'; break;
				case BETA:			*s++ = 'b'; break;
				case GAMMA:			*s++ = 'g'; break;
				case DELTA:			*s++ = 'd'; break;
				case EPSILON:		*s++ = 'e'; break;
				case ZETA:			*s++ = 'z'; break;
				case ETA:			*s++ = 'e'; *s++ = '^'; break;
				case THETA:			*s++ = 't'; *s++ = 'h'; break;
				case IOTA:			*s++ = 'i'; break;
				case KAPPA:			*s++ = 'k'; break;
				case LAMBDA:		*s++ = 'l'; break;
				case MU:			*s++ = 'm'; break;
				case NU:			*s++ = 'n'; break;
				case XI:			*s++ = 'x'; break;
				case OMICRON:		*s++ = 'o'; break;
				case PI:			*s++ = 'p'; break;
				case RHO:			*s++ = 'r'; break;
				case SIGMA:			*s++ = 's'; break;
				case TAU:			*s++ = 't'; break;
				case UPSILON:		*s++ = 'u'; break;
				case PHI:			*s++ = 'p'; *s++ = 'h'; break;
				case CHI:			*s++ = 'c'; *s++ = 'h'; break;
				case PSI:			*s++ = 'p'; *s++ = 's'; break;
				case OMEGA:			*s++ = 'o'; *s++ = '^'; break;
				case LOW_I_PRE:		if (!prev_is_low_i) { *s++ = 'i'; *s++ = '_'; } break;
			}
			prev_is_low_i = GREEKCHARCAP(gcc) == LOW_I_PRE;
			first_greek = false;
		}
	}
	*s = '\0';

	return buf;
}

void print_gcc(lword gcc)
{
	if (gcc & TILDE)
		printf("TILDE-");
			
	if (gcc & NASP)
		printf("NASP-");
	if (gcc & ASP)
		printf("ASP-");
			
	if (gcc & UML)
		printf("UML-");
	if (gcc & GRAVE)
		printf("GRAVE-");
	if (gcc & ACUTE)
		printf("ACUTE-");
			
	switch(GREEKCHARCAP(gcc))
	{	case ALPHA|CAP:		printf("CAP-ALPHA "); break;
		case BETA|CAP:		printf("CAP-BETA "); break;
		case GAMMA|CAP:		printf("CAP-GAMMA "); break;
		case DELTA|CAP:		printf("CAP-DELTA "); break;
		case EPSILON|CAP:	printf("CAP-EPSILON "); break;
		case ZETA|CAP:		printf("CAP-ZETA "); break;
		case ETA|CAP:		printf("CAP-ETA "); break;
		case THETA|CAP:		printf("CAP-THETA "); break;
		case IOTA|CAP:		printf("CAP-IOTA "); break;
		case KAPPA|CAP:		printf("CAP-KAPPA "); break;
		case LAMBDA|CAP:	printf("CAP-LAMBDA "); break;
		case MU|CAP:		printf("CAP-MU "); break;
		case NU|CAP:		printf("CAP-NU "); break;
		case XI|CAP:		printf("CAP-XI "); break;
		case OMICRON|CAP:	printf("CAP-OMICRON "); break;
		case PI|CAP:		printf("CAP-PI "); break;
		case RHO|CAP:		printf("CAP-RHO "); break;
		case SIGMA|CAP:		printf("CAP-SIGMA "); break;
		case TAU|CAP:		printf("CAP-TAU "); break;
		case UPSILON|CAP:	printf("CAP-UPSILON "); break;
		case PHI|CAP:		printf("CAP-PHI "); break;
		case CHI|CAP:		printf("CAP-CHI "); break;
		case PSI|CAP:		printf("CAP-PSI "); break;
		case OMEGA|CAP:		printf("CAP-OMEGA "); break;
		case ALPHA:			printf("ALPHA "); break;
		case BETA:			printf("BETA "); break;
		case GAMMA:			printf("GAMMA "); break;
		case DELTA:			printf("DELTA "); break;
		case EPSILON:		printf("EPSILON "); break;
		case ZETA:			printf("ZETA "); break;
		case ETA:			printf("ETA "); break;
		case THETA:			printf("THETA "); break;
		case IOTA:			printf("IOTA "); break;
		case KAPPA:			printf("KAPPA "); break;
		case LAMBDA:		printf("LAMBDA "); break;
		case MU:			printf("MU "); break;
		case NU:			printf("NU "); break;
		case XI:			printf("XI "); break;
		case OMICRON:		printf("OMICRION "); break;
		case PI:			printf("PI "); break;
		case RHO:			printf("RHO "); break;
		case SIGMA:			printf("SIGMA "); break;
		case TAU:			printf("TAU "); break;
		case UPSILON:		printf("UPSILON "); break;
		case PHI:			printf("PHI "); break;
		case CHI:			printf("CHI "); break;
		case PSI:			printf("PSI "); break;
		case OMEGA:			printf("OMEGA "); break;
		case LOW_I_PRE:		printf("LOW_I_PRE "); break;
		default:			printf("??? "); break;
	}
}

inline char inv_greek_char_code(long gcc)
{
	return gcc_to_ch[gcc];
	/*for (int i = 1; i < 256; i++)
		if (ch_to_gcc[i] == gcc)
			return i;

	return 0;*/
}

char hexvalue(char s)
{	
	return ('0' <= s && s <= '9') ? s - '0' :
		   ('a' <= s && s <= 'f') ? s - 'a' + 10 :
		   ('A' <= s && s <= 'F') ? s - 'A' + 10 : 0;
}

char *text_to_greek(char *greek_trans, byte *as_hex = 0)
{	
	if (do_init_greek) init_greek();

	char *buf = temp_char1000_buf();
	
	char *s = buf;
	for (; *greek_trans != '\0'; )
	{
		if (*greek_trans == '#')
		{	if (isxdigit(greek_trans[1]) && isxdigit(greek_trans[2]))
			{	*s++ =  16 * hexvalue(greek_trans[1]) + hexvalue(greek_trans[2]);
				if (as_hex != 0)
					*as_hex++ = 1;
				greek_trans += 3;
			}				
			else
				greek_trans++;
		}
		else
		{
			long gcc = 0;
			
			bool go = true;
			for (; *greek_trans != '\0' && go; greek_trans++)
			{
				go = false;
				switch(*greek_trans)
				{	case '~'	: gcc |= TILDE; 		go = true; break;
					case '\''	: gcc |= NASP; 			go = true; break;
					case 'h'	: gcc |= ASP; 			go = true; break;
					case '"'	: gcc |= UML;	 		go = true; break;
					case '\\'	: gcc |= GRAVE; 		go = true; break;
					case '/'	: gcc |= ACUTE; 		go = true; break;
					case 'A'	: gcc |= ALPHA|CAP; 	break;
					case 'B'	: gcc |= BETA|CAP; 		break;
					case 'C'	: if (greek_trans[1] == 'h') { 
					              gcc |= CHI|CAP; 		greek_trans++; break; }
								  break;
					case 'D'	: gcc |= DELTA|CAP; 	break;
					case 'E'	: if (greek_trans[1] == '^') {
								  gcc |= ETA|CAP;  		greek_trans++; break; }
								  gcc |= EPSILON|CAP;	break;
					case 'G'	: gcc |= GAMMA|CAP; 	break;
					case 'I'	: gcc |= IOTA|CAP; 		break;
					case 'K'	: gcc |= KAPPA|CAP;		break;
					case 'L'	: gcc |= LAMBDA|CAP;	break;
					case 'M'	: gcc |= MU|CAP;		break;
					case 'N'	: gcc |= NU|CAP;		break;
					case 'O'	: if (greek_trans[1] == '^') {
								  gcc |= OMEGA|CAP;		greek_trans++; break; }
								  gcc |= OMICRON|CAP;	break;
					case 'P'	: if (greek_trans[1] == 'h') {
								  gcc |= PHI|CAP;		greek_trans++; break; }
								  if (greek_trans[1] == 's') {
								  gcc |= PSI|CAP;		greek_trans++; break; }
								  gcc |= PI|CAP;		break;
					case 'S'	: gcc |= SIGMA|CAP;		break;
					case 'R'	: gcc |= RHO|CAP;		break;
					case 'T'	: if (greek_trans[1] == 'h') {
								  gcc |= THETA|CAP;		greek_trans++; break; }
								  gcc |= TAU|CAP;		break;
					case 'X'	: gcc |= XI|CAP;		break;
					case 'Y'	: gcc |= UPSILON|CAP;	break;
					case 'Z'	: gcc |= ZETA|CAP; 		break;
					case 'a'	: gcc |= ALPHA;			break;
					case 'b'	: gcc |= BETA;			break;
					case 'c'	: if (greek_trans[1] == 'h') { 
					              gcc |= CHI; 			greek_trans++; break; }
								  break;
					case 'd'	: gcc |= DELTA;			break;
					case 'e'	: if (greek_trans[1] == '^') {
								  gcc |= ETA;			greek_trans++; break; }
								  gcc |= EPSILON;		break;
					case 'g'	: gcc |= GAMMA;			break;
					case 'i'	: if (greek_trans[1] == '_') {
								  gcc |= LOW_I_PRE;		greek_trans++; break; }
								  gcc |= IOTA;			break;
					case 'k'	: gcc |= KAPPA;			break;
					case 'l'	: gcc |= LAMBDA;		break;
					case 'm'	: gcc |= MU;			break;
					case 'n'	: gcc |= NU;			break;
					case 'o'	: if (greek_trans[1] == '^') {
								  gcc |= OMEGA;			greek_trans++; break; }
								  gcc |= OMICRON;		break;
					case 'p'	: if (greek_trans[1] == 'h') {
								  gcc |= PHI;			greek_trans++; break; }
								  if (greek_trans[1] == 's') {
								  gcc |= PSI;			greek_trans++; break; }
								  gcc |= PI;			break;
					case 'r'	: gcc |= RHO;			break;
					case 's'	: gcc |= SIGMA;			break;
					case 't'	: if (greek_trans[1] == 'h') {
								  gcc |= THETA;			greek_trans++; break; }
								  gcc |= TAU;			break;
					case 'u'	: gcc |= UPSILON;		break;
					case 'x'	: gcc |= XI;			break;
					case 'z'	: gcc |= ZETA;			break;
					case '|'	: gcc |= NASP;			break;
					default: go = false; greek_trans--; break;
				}
			}
			
			if (gcc == 0)
			{
				if (*greek_trans == ';')
				{	*s++ = (char)0xAF;
					if (as_hex != 0)
						*as_hex++ = 0;
					greek_trans++;
				}
				else
				{	*s++ = *greek_trans++;
					if (as_hex != 0)
						*as_hex++ = 0;
				}
			}
			else
			{
				char ch = inv_greek_char_code(gcc);
				if (ch != 0)
				{
					*s++ = ch;
					if (as_hex != 0)
						*as_hex++ = 0;
				}
				else
				{	char chacc = inv_greek_char_code(gcc & ~(31|CAP));
					ch = inv_greek_char_code(GREEKCHARCAP(gcc));
					if (chacc != 0 && ch != 0)
					{	*s++ = chacc;
						*s++ = ch;
						if (as_hex != 0)
						{	*as_hex++ = 0;
							*as_hex++ = 0;
						}
					}
				}
			}
		}
	}
	*s = '\0';	
	
	return buf;
}


// ----------- Transliteration --------------

char *transliterate(const char *greek_word)
// Returns the transliteration of the given Greek word
{
	static char buf[1000];
	char *s = buf;
	int low_i_pre = 0;
	
	const char *r = greek_word;

	bool at_start = true;
	for (; *r != '\0'; r++)
	{
		long gcc = greek_char_code(r[0]);
		if (at_start)
		{
			if (GREEKCHAR(gcc) == RHO && GREEKASP(gcc) == ASP)
			{	*s++ = GREEKCAP(gcc) == CAP ? 'R' : 'r';
				*s++ = 'h';
				r++;
			}
			else if (gcc == ASP)
			{	long ngc = greek_char_code(greek_word[1]);
				if (GREEKCHAR(ngc) == RHO)
				{	*s++ = GREEKCAP(ngc) == CAP ? 'R' : 'r';
					*s++ = 'h';
					r += 2;
				}
				else
				{	*s++ = 'h';
					r++;
				}
			}
			else if (   GREEKASP(gcc) == ASP
				     || GREEKASP(greek_char_code(greek_word[1])) == ASP)
				*s++ = 'h';
			else if (gcc == NASP || gcc == (NASP|ACUTE))
				r++;
			gcc = greek_char_code(r[0]);
			if (gcc == ACUTE)
			{	r++;
				gcc = greek_char_code(r[0]);
			}
			at_start = false;	
		}
				
		switch(GREEKCHARCAP(gcc))
		{	case ALPHA|CAP:		*s++ = 'A'; break;
			case BETA|CAP:		*s++ = 'B'; break;
			case GAMMA|CAP:		*s++ = 'G'; break;
			case DELTA|CAP:		*s++ = 'D'; break;
			case EPSILON|CAP:	*s++ = 'E'; break;
			case ZETA|CAP:		*s++ = 'Z'; break;
			case ETA|CAP:		*s++ = 'E'; *s++ = '^'; break;
			case THETA|CAP:		*s++ = 'T'; *s++ = 'h'; break;
			case IOTA|CAP:		*s++ = 'I'; break;
			case KAPPA|CAP:		*s++ = 'K'; break;
			case LAMBDA|CAP:	*s++ = 'L'; break;
			case MU|CAP:		*s++ = 'M'; break;
			case NU|CAP:		*s++ = 'N'; break;
			case XI|CAP:		*s++ = 'X'; break;
			case OMICRON|CAP:	*s++ = 'O'; break;
			case PI|CAP:		*s++ = 'P'; break;
			case RHO|CAP:		*s++ = 'R'; break;
			case SIGMA|CAP:		*s++ = 'S'; break;
			case TAU|CAP:		*s++ = 'T'; break;
			case UPSILON|CAP:	*s++ = 'U'; break;
			case PHI|CAP:		*s++ = 'P'; *s++ = 'h'; break;
			case CHI|CAP:		*s++ = 'C'; *s++ = 'h'; break;
			case PSI|CAP:		*s++ = 'P'; *s++ = 's'; break;
			case OMEGA|CAP:		*s++ = 'O'; *s++ = '^'; break;
			case ALPHA:			*s++ = 'a'; if (low_i_pre == 1) *s++ = '^'; break;
			case BETA:			*s++ = 'b'; break;
			case GAMMA:			*s++ = 'g'; break;
			case DELTA:			*s++ = 'd'; break;
			case EPSILON:		*s++ = 'e'; break;
			case ZETA:			*s++ = 'z'; break;
			case ETA:			*s++ = 'e'; *s++ = '^'; break;
			case THETA:			*s++ = 't'; *s++ = 'h'; break;
			case IOTA:			*s++ = (gcc & UML) ? '' : 'i'; break;
			case KAPPA:			*s++ = 'k'; break;
			case LAMBDA:		*s++ = 'l'; break;
			case MU:			*s++ = 'm'; break;
			case NU:			*s++ = 'n'; break;
			case XI:			*s++ = 'x'; break;
			case OMICRON:		*s++ = 'o'; break;
			case PI:			*s++ = 'p'; break;
			case RHO:			*s++ = 'r'; break;
			case SIGMA:			*s++ = 's'; break;
			case TAU:			*s++ = 't'; break;
			case UPSILON:		*s++ = (gcc & UML) ? '' : 'u'; break;
			case PHI:			*s++ = 'p'; *s++ = 'h'; break;
			case CHI:			*s++ = 'c'; *s++ = 'h'; break;
			case PSI:			*s++ = 'p'; *s++ = 's'; break;
			case OMEGA:			*s++ = 'o'; *s++ = '^';
								break;
			case LOW_I_PRE:		low_i_pre = 2; break;
			default:
				if (gcc == NASP)
					*s++ = '';
				else if (gcc == 0)
				{	if (r[0] == ' ')
					{	*s++ = ' ';
						at_start = true;
					}
					else if (r[0] == 0x2F)
					{	*s++ = '/';
						at_start = true;
					}
				}
				break;
		
		}
		if (low_i_pre == 1)
			*s++ = 'i';
		if (low_i_pre > 0)
			low_i_pre--;
	}
	*s = '\0';	
	return buf;
}


char *transl_to_text(const char *transl)
{	
	char *buf = temp_char1000_buf();
	char *r = buf;
	for (const char *s = transl; *s != '\0'; s++)
		if ((' ' <= *s && *s < 127) || *s == '' || *s == '' || *s == '')
			*r++ = *s;
		else
		{	sprintf(r, "#%02X", (byte)*s);
			r += 3;
		}
	*r = '\0';
	return buf;
}



// ------- Compare Greek with Greek ----------------

#define DIFF_CAP			(1L<<0)
#define DIFF_STRESS			(1L<<1)
#define DIFF_ACC			(1L<<2)
#define DIFF_DEL_EPSILON	(1L<<3)
#define DIFF_DEL_ETA		(1L<<4)
#define DIFF_D_OMEGA		(1L<<5)
#define DIFF_NASP			(1L<<6)
#define DIFF_NASP_OMICRON	(1L<<7)
#define DIFF_DEL_LOW_I_PRE	(1L<<8)
#define DIFF_INS_LOW_I_PRE	(1L<<9)
#define DIFF_SIGMA			(1L<<10)
#define DIFF_INS_NASP		(1L<<11)
#define DIFF_DEL_NASP		(1L<<12)
#define DIFF_SS_TT			(1L<<13)
#define DIFF_DEL_IOTA		(1L<<14)
#define DIFF_INS_IOTA		(1L<<15)
#define DIFF_VARIATION(X)	((X)<(1L<<16))
#define DIFF_SUBSTANTIAL(X)	((X)>=(1L<<16))
#define DIFF_ASP			(1L<<16)
#define DIFF_NU_UPSILON		(1L<<17)
#define DIFF_IGN_FIRST		(1L<<18)
#define DIFF_CORRECTING(X)	(DIFF_SUBSTANTIAL(X)&&GET_DIFF_CHAR(X)==0)
#define SET_DIFF_CHAR(X)	((X)<<19)
#define GET_DIFF_CHAR(X)	((X)>>19)
#define DIFF_ALL			(~0)

bool dd = false;

lword greek_word_diff1(const char *s, const char *r, char *corr_word)
// (private methode, should not be called directly)
{
	lword result = 0;
	char *t = corr_word;
	word diff_char = 0;
	
	if (strcmp(s, r) == 0)
	{	strcpy(t, s);
		return 0;
	}
	
	if (dd)
	{	printf("\n%s = %s, s=", greek_to_text(s), greek_to_text(r));
		print_gcc(greek_char_code(s[0]));
		printf("r=");
		print_gcc(greek_char_code(r[0]));
	}

	// skip intial non-asparation character
	if (   s[0] != r[0]
		&& (greek_char_code(r[0]) == NASP || greek_char_code(r[0]) == ASP)
		&& GREEKCHAR(greek_char_code(s[0])) == GREEKCHAR(greek_char_code(r[1])))
	{	result |= DIFF_ASP;
		*t++ = *r++;
	}
		
	for (; *s || *r; )
	{	
		long gcc_s = greek_char_code(*s);
		long gcc_r = greek_char_code(*r);
		
		if (dd)
		{	printf("\n%s = %s, s=", greek_to_text(s), greek_to_text(r));
			print_gcc(gcc_s);
			printf("r=");
			print_gcc(gcc_r);
		}
		
		if (   gcc_r == (EPSILON|ACUTE)
		    && GREEKCHARSTRESS(gcc_s) == GREEKCHARSTRESS(greek_char_code(r[1]))
		    && (   GREEKCHAR(gcc_s) != EPSILON
		        || GREEKCHAR(greek_char_code(s[1])) != EPSILON))
		{	result |= DIFF_DEL_EPSILON;
			r++;
		} 
		else if (   gcc_r == ETA
		         && GREEKCHARSTRESS(gcc_s) == GREEKCHARSTRESS(greek_char_code(r[1]))
			     && (   GREEKCHAR(gcc_s) != ETA
			         || GREEKCHAR(greek_char_code(s[1])) != ETA))
		{	result |= DIFF_DEL_ETA;
			r++;
		} 
		else if (   gcc_r == IOTA
		         && GREEKCHARSTRESS(gcc_s) == GREEKCHARSTRESS(greek_char_code(r[1]))
			     && (   GREEKCHAR(gcc_s) != IOTA
			         || GREEKCHAR(greek_char_code(s[1])) != IOTA))
		{	result |= DIFF_DEL_IOTA;
			r++;
		} 
		else if (   gcc_s == IOTA
		         && GREEKCHARSTRESS(gcc_r) == GREEKCHARSTRESS(greek_char_code(s[1]))
			     && (   GREEKCHAR(gcc_r) != IOTA
			         || GREEKCHAR(greek_char_code(r[1])) != IOTA))
		{	result |= DIFF_INS_IOTA;
			*t++ = *s++;
		} 
		else if (   GREEKCHAR(gcc_s) == OMEGA
		         && GREEKCHAR(gcc_r) == OMEGA
		         && GREEKCHAR(greek_char_code(s[1])) == OMEGA
		         && GREEKCHAR(greek_char_code(r[1])) != OMEGA)
		{	result |= DIFF_D_OMEGA;
			*t++ = *s++;
		}
		else if (	gcc_s == TAU 
				 && gcc_r == SIGMA
				 && greek_char_code(s[1]) == TAU
				 && greek_char_code(r[1]) == SIGMA)
		{	result |= DIFF_SS_TT;
			*t++ = *s++;
			*t++ = *s++;
			r += 2;
		}
		else if (   gcc_s == NASP && s[1] == '\0'
				 && r[0] == '\0')
		{	result |= DIFF_NASP;
			*t++ = *s++;
		}
		else if (   gcc_s == NASP && s[1] == '\0'
				 && gcc_r == OMICRON && r[1] == '\0')
		{	result |= DIFF_NASP_OMICRON;
			*t++ = *s++;
			r++;
		}
		else if (	(gcc_s == NU && GREEKCHAR(gcc_r) == UPSILON)
				 || (gcc_r == NU && GREEKCHAR(gcc_s) == UPSILON))
		{	result |= DIFF_NU_UPSILON;
			s++;
			*t++ = *r++;
		}
		else if (   gcc_s == LOW_I_PRE
		         && gcc_r != LOW_I_PRE)
		{	result |= DIFF_INS_LOW_I_PRE;
			*t++ = *s++;
		}
		else if (   gcc_s != LOW_I_PRE
		         && gcc_r == LOW_I_PRE)
		{	result |= DIFF_DEL_LOW_I_PRE;
			r++;
		}
		else if (   gcc_s == NASP
				 && s[1] == '\0'
				 && r[0] == '\0')
		{	result |= DIFF_INS_NASP;
			*t++ = *s++;
		}
		else if (   gcc_r == NASP
				 && r[1] == '\0'
				 && s[0] == '\0')
		{	result |= DIFF_DEL_NASP;
			r++;
		}
		else if (	GREEKCHAR(gcc_r) == SIGMA
				 && s[0] == '\0'
				 && r[1] == '\0')
		{	result |= DIFF_SIGMA;
			r++;
		}
		else if (   *s == '\0' || *r == '\0' 
		         || GREEKCHAR(gcc_s) != GREEKCHAR(gcc_r))
		{	diff_char++;
			if (*s)
				s++;
			if (*r)
				*t++ = *r++;
		}
		else
		{	/*if (GREEKSTRESS(gcc_s) != GREEKSTRESS(gcc_r))
				result |= DIFF_STRESS;*/
			if (GREEKACC(gcc_s) != GREEKACC(gcc_r))
				result |= DIFF_ACC;
			if (GREEKCAP(gcc_s) != GREEKCAP(gcc_r))
				result |= DIFF_CAP;
			if (GREEKASP(gcc_s) != GREEKASP(gcc_r))
			{	result |= DIFF_ASP;
				char ch = inv_greek_char_code(GREEKNOASP(gcc_s) | GREEKASP(gcc_r));
				*t++ = (ch != 0) ? ch : *r;
			}
			else
				*t++ = *s;
			s++;
			r++;
		}
		if (dd)
		{	*t = '\0';
			printf(" => %s", greek_to_text(corr_word));
		}
	}
	*t = '\0';
	
	result |= SET_DIFF_CHAR(diff_char);
	return result;
}

lword greek_word_diff(const char *greek1, const char *greek2, char *corr_word)
// Returns a code representing the differences found. Zero means no differences.
// The first parameter contains the word from the text, the second parameter
// the word from the word study. The third parameter will contain the corrected
// word, in case there is a correction.
{
	lword diff = greek_word_diff1(greek1, greek2, corr_word);
	if (GET_DIFF_CHAR(diff) > 0)
	{	char buf[200];
		lword diff2 = greek_word_diff1(greek1+1, greek2, buf) | DIFF_IGN_FIRST;
		if (diff2 < diff)
		{	diff = diff2;
			strcpy(corr_word, buf);
		}
	}
	return diff;
}

lword cgw[10] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

bool compare_greek_word(char *greek, const char *ws_greek, 
                        lword &best_diff, char *best_word)
// Compares a Greek word (in greek) with one (or more) Greek words (in ws_greek).
// Returns true if a better match is found. best_diff contains the best difference
// (least differences) found so far, and best_word is filled with the word.
{	
	bool found_better = false;
	
	char buf[1000];
	strcpy(buf, ws_greek);
	char *r = buf;
	
	for(;;)
	{	char *sl = strchr(r, '/');
		if (sl) 
			*sl = '\0';
		
		char corr_word[200]; // dummy
		lword diff = greek_word_diff(greek, r, corr_word);
		if (diff < best_diff)
		{	best_diff = diff;
			strcpy(best_word, r);
			if (diff == 0)
				return true; // cannot get any better
			found_better = true;
		}
			
		if (sl == NULL)
			break;
		r = sl+1;
	}
	return found_better;
}

void print_greek_word_diff(lword diff)
{
	if (diff & DIFF_CAP)			printf(" hoofdletter");
	if (diff & DIFF_ASP)			printf(" aspiratie");
	if (diff & DIFF_STRESS)			printf(" klemtoon");
	if (diff & DIFF_ACC)			printf(" accenten");
	if (diff & DIFF_DEL_EPSILON)	printf(" weglaten-epsilon");
	if (diff & DIFF_DEL_ETA)		printf(" weglaten-eta");
	if (diff & DIFF_D_OMEGA)		printf(" dubbele-omega");
	if (diff & DIFF_NASP)			printf(" extra-'");
	if (diff & DIFF_NASP_OMICRON)	printf(" '-o");
	if (diff & DIFF_INS_LOW_I_PRE)	printf(" toevoegen-subscript-iota");
	if (diff & DIFF_DEL_LOW_I_PRE)	printf(" weglaten-subscript-iota");
	if (diff & DIFF_NU_UPSILON)		printf(" nu-upsilon-verwisseling");
	if (diff & DIFF_SIGMA)			printf(" sigma");
	if (diff & DIFF_INS_NASP)		printf(" toevoegen-'");
	if (diff & DIFF_DEL_NASP)		printf(" ontbrekende-'");
	if (diff & DIFF_INS_IOTA)		printf(" toevoegen-iota");
	if (diff & DIFF_DEL_IOTA)		printf(" weglaten-iota");
	if (diff & DIFF_SS_TT)			printf(" vervanging-sigma-tau");
}



// ----- Compare transliterations ------------

#define TR_DIFF_ASP			(1 << 0)
#define TR_DIFF_DASH_ADD	(1 << 1)
#define TR_DIFF_DASH_DEL	(1 << 2)
#define TR_DIFF_UUUML		(1 << 3)
#define TR_DIFF_UUMLU		(1 << 4)
#define TR_DIFF_IIUML		(1 << 5)
#define TR_DIFF_IUMLI		(1 << 6)
#define TR_DIFF_CAP			(1 << 7)
#define TR_DIFF_THNASP		(1 << 8)
#define TR_DIFF_PHNASP		(1 << 9)
#define TR_DIFF_NASP		(1 << 10)
#define TR_CORR  (TR_DIFF_ASP|TR_DIFF_UUUML|TR_DIFF_UUMLU|TR_DIFF_IIUML|TR_DIFF_IUMLI|TR_DIFF_THNASP|TR_DIFF_PHNASP)

bool compare_transl(const char *transl_1, const char *transl_2, word &warnings,
					char *corr_transl = 0)
{
	warnings = 0;

	const char *s = transl_1;
	const char *r = transl_2;
	char dummy[200];
	char *t = corr_transl ? corr_transl : dummy;

	while (*s != '\0' || *r != '\0')
		if (   (*s == ' ' || *s == '/')
			&& (*r == ' ' || *r == '/'))
		{
			while (*s == ' ' || *s == '/') s++;
			while (*r == ' ' || *r == '/') r++;
		}
		else if (*s == *r)
		{
			if (   (s[1] == '\0' || ((s[1] == ''||s[1] == '\'') && s[2] == '\0'))
				&& r[0] == 't' && r[1] == 'h' && (r[2] == ''||r[2] == '\'') && r[3] == '\0')
			{	warnings |= TR_DIFF_THNASP;
				s += s[1] == '' ? 2 : 1;
				r += 3;
				*t++ = 't';
				*t++ = 'h';
				*t++ = '';
			}
			else if (   (s[1] == '\0' || ((s[1] == ''||s[1] == '\'') && s[2] == '\0'))
				&& r[0] == 'p' && r[1] == 'h' && (r[2] == ''||r[2] == '\'') && r[3] == '\0')
			{	warnings |= TR_DIFF_PHNASP;
				s += s[1] == '' ? 2 : 1;
				r += 3;
				*t++ = 'p';
				*t++ = 'h';
				*t++ = '';
			}
			else if (   s[1] == '^' && r[1] != '^' 
			         && (*s == 'a' || *s == 'u' || *s == 'i'))
			{	warnings |= TR_DIFF_DASH_ADD;
				*t++ = *s++;
				*t++ = *s++;
				r++;
			}
			else if (   s[1] != '^' && r[1] == '^' 
					 && (*s == 'a' || *s == 'u' || *s == 'i'))
			{	warnings |= TR_DIFF_DASH_DEL;
				*t++ = *s++;
				r += 2;
			}
			else
			{	*t++ = *s++;
				r++;
			}
		}
		else if (tolower(*s) == tolower(*r))
		{	warnings |= TR_DIFF_CAP;
			*t++ = *s++;
			r++;
		}
		else if (*s == '' && *r == 'i')
		{	warnings |= TR_DIFF_IUMLI;
			s++;
			*t++ = *r++;
		}
		else if (*s == 'i' && *r == '')
		{	warnings |= TR_DIFF_IIUML;
			s++;
			*t++ = *r++;
		}
		else if (*s == '' && *r == 'u')
		{	warnings |= TR_DIFF_UUMLU;
			s++;
			*t++ = *r++;
		}
		else if (*s == 'u' && *r == '')
		{	warnings |= TR_DIFF_UUUML;
			s++;
			*t++ = *r++;
		}
		else if (   (*s == '' && *r == '\'')
				 || (*s == '\'' && *r == ''))
		{	warnings |= TR_DIFF_ASP;
			s++;
			r++;
			*t++ = '';
		}
		else if (*s == '')// && *r == '\0' && (s[1] == '\0' || s[1] == ' ' || ))
		{	warnings |= TR_DIFF_NASP;
			*t++ = *s++;
		}
		else if (*r == '')// && *s == '\0' && (r[1] == '\0' || r[1] == ' '))
		{	warnings |= TR_DIFF_NASP;
			r++;
		}
		else if (*r == '-')
		{	r++;
			if (   (*s == '' && *r == 'u')
			    || (*s == '' && *r == 'i'))
			{	*t++ = *s++;
				r++;
			}
		}
		else if (*s == '-')
		{	*t++ = *s++;
			if (   (*s == 'u' && *r == '')
			    || (*s == 'i' && *r == ''))
			{	*t++ = *s++;
				r++;
			}
		}
		else
			break;

	if (*r == ' ')
		r++;
	if (*s == ' ')
		s++;
	*t = '\0';

	return *s == '\0' && *r == '\0';
}

bool compare_transl_with_greek(const char *transl, const char *greek, word &warnings,
							   char *corr_transl)
{
	return compare_transl(transl, transliterate(greek), warnings, corr_transl);
}

bool compare_transl_with_transls(char *transl, const char *transls, word &warnings, 
								 char *best_transl)
// Compare the transliteration from the text (in trans) with the one (or more)
// transliteration(s) from the word study (in transls). Returns true if
// they match. Possible small differences are reported in warnings.
{ 
	warnings = 0;
	const char *r = transls;
	for (;;)
	{
		while (*r == ' ' || *r == '/')
			r++;
		
		if (*r == '\0')
			break;
		
		char buf[100];
		int i = 0;
		for (; *r != '\0' && *r != ' ' && *r != '/'; r++)
			if (i < 99)
				buf[i++] = *r;
		buf[i] = '\0';
		
		warnings = 0;
		if (compare_transl(transl, buf, warnings, 0))
		{	strcpy(best_transl, buf);
			return TRUE;
		}
	}
	strcpy(best_transl, transls);
	return FALSE;
}

bool compare_transl_with_greeks(const char *transl, const char *greeks, word &warnings,
								char *best_greek)
// Compares a transliteration with the Greek word. Returns true if they match.
// Small differences are represented in variable warnings.
{
	const char *r = greeks;
	for (;;)
	{
		while (*r == ' ' || *r == 0x2F )
			r++;
		
		if (*r == '\0')
			break;
		
		char buf[100];
		int i = 0;
		for (; *r != '\0' && *r != ' ' && *r != 0x2F; r++)
			if (i < 99)
				buf[i++] = *r;
		buf[i] = '\0';
		
		warnings = 0;
		if (compare_transl(transl, transliterate(buf), warnings, 0))
		{	strcpy(best_greek, buf);
			return TRUE;
		}
	}
	strcpy(best_greek, greeks);
	return FALSE;
}

bool compare_greek_with_transls(const char *greek, const char *transls,
								word &warnings)
{
	char best_transl[200];
	return compare_transl_with_transls(transliterate(greek), transls, warnings,
									   best_transl);
}


void print_transl_diffs(word warnings)
{
	if (warnings & TR_DIFF_DASH_ADD)
		printf(" ^-toevoeging");
	if (warnings & TR_DIFF_DASH_DEL)
		printf(" ^-weglating");
	if (warnings & TR_DIFF_IUMLI)
		printf(" -i");
	if (warnings & TR_DIFF_IIUML)
		printf(" i-");
	if (warnings & TR_DIFF_UUMLU)
		printf(" -u");
	if (warnings & TR_DIFF_UUUML)
		printf(" u-");
	if (warnings & TR_DIFF_CAP)
		printf(" hoofdletters");
	if (warnings & TR_DIFF_THNASP)
		printf(" th-t()");
	if (warnings & TR_DIFF_PHNASP)
		printf(" ph-p()");
	if (warnings & TR_DIFF_NASP)
		printf(" ");
}

void print_transl_diffs_inv(word warnings)
{
	if (warnings & TR_DIFF_DASH_ADD)
		printf(" ^-weglating");
	if (warnings & TR_DIFF_DASH_DEL)
		printf(" ^-toevoeging");
	if (warnings & TR_DIFF_IUMLI)
		printf(" i-");
	if (warnings & TR_DIFF_IIUML)
		printf(" -i");
	if (warnings & TR_DIFF_UUMLU)
		printf(" u-");
	if (warnings & TR_DIFF_UUUML)
		printf(" -u");
	if (warnings & TR_DIFF_CAP)
		printf(" hoofdletters");
	if (warnings & TR_DIFF_THNASP)
		printf(" t()-th");
	if (warnings & TR_DIFF_PHNASP)
		printf(" p()-ph");
	if (warnings & TR_DIFF_NASP)
		printf(" ");
}


// ------- Find corrections ------------

bool find_greek_matching_transl(const char *ws_greek, char *alt_greek, 
								const char *transl)
{
	word best_warnings = 0xFFFF;
	
	const char *r = ws_greek;
	for (;;)
	{
		while (*r == ' ' || *r == 0x2F )
			r++;
		
		if (*r == '\0')
			break;
		
		char buf[100];
		int i = 0;
		for (; *r != '\0' && *r != ' ' && *r != 0x2F; r++)
			if (i < 99)
				buf[i++] = *r;
		buf[i] = '\0';
		
		word warnings;
		if (compare_transl_with_greek(transl, buf, warnings, 0))
		{	if (warnings < best_warnings)
			{	best_warnings = warnings;
				strcpy(alt_greek, buf);
			}
			if (warnings == 0)
				return true;
		}
	}
	
	return best_warnings != 0xFFFF;
}

bool find_transl_matching_greek(const char *ws_transl, char *alt_transl, 
								const char *greek)
{
	word best_warnings = 0xFFFF;
	
	const char *r = ws_transl;
	for (;;)
	{
		while (*r == ' ' || *r == '/')
			r++;
		
		if (*r == '\0')
			break;
		
		char buf[100];
		int i = 0;
		for (; *r != '\0' && *r != ' ' && *r != '/'; r++)
			if (i < 99)
				buf[i++] = *r;
		buf[i] = '\0';
		
		word warnings;
		if (compare_transl_with_greek(buf, greek, warnings, 0))
		{	if (warnings < best_warnings)
			{	best_warnings = warnings;
				strcpy(alt_transl, buf);
			}
			if (warnings == 0)
				return true;
		}
	}
	
	return best_warnings != 0xFFFF;
}

bool isgreek(char ch)
{
	return
	   "                "
	   "                "
	   "gg     ggggggggg"
	   " ggggggggg g   g"
	   " gg gggggggggggg"
	   "ggggggg ggggggg "
	   " ggggggg ggg ggg"
	   "ggggg  gggg     "
	   "gggggggggggggggg"
	   "gggggggggggggggg"
	   " gggggg ggg  g g"
	   "ggggggggggggg gg"
	   "ggggggg   g g  g"
	   "     gg g  gggg "
	   "gggggggggggggggg"
	   "gggggggggggggggg"
	[(byte)ch] == 'g';
}

char *greek_to_greek(const char *greek_word)
{
	for (const char *s = greek_word; *s != '\0'; s++)
		if (*s == '}')
		{	fprintf(stderr, "problem with: |%s|\n", greek_word);
			break;
		}
	char *buf = temp_char1000_buf();
	char *s = buf;
	for (const char *ch = greek_word; *ch != '\0'; ch++)
		if (*ch == (char)0xF3 && (ch[1] == '\0' || greek_char_code(ch[1]) == 0))
			*s++ = (char)0xF7;
		else
			*s++ = *ch;
	*s = '\0';	
	return buf;
}

char *greek_to_hexadecimal(const char *greek_word)
{
	for (const char *s = greek_word; *s != '\0'; s++)
		if (*s == '}')
		{	fprintf(stderr, "problem with: |%s|\n", greek_word);
			break;
		}
	char *buf = temp_char1000_buf();
	char *s = buf;
	for (const char *ch = greek_word; *ch != '\0'; ch++)
	{
		if (*ch == (char)0xF3 && (ch[1] == '\0' || greek_char_code(ch[1]) == 0))
			sprintf(s, "F7"); 
		else
			sprintf(s, "%02X", (const byte)*ch);
		s += 2;
	}
	*s = '\0';	
	return buf;
}
