CDFOutput cdf_output;

char* (*greek_to_output)(const char *greek_word);

bool in_book;
bool in_verse;
bool in_col;
bool in_col1_words;

void output_start_bible_books()
{
	in_book = false;
	in_verse = false;
	in_col = false;
	in_col1_words = false;
}

void output_end_book()
{
	if (in_col) { cdf_output.close_list(); in_col = false; }
	if (in_verse) { cdf_output.close_record(); in_verse = false; }
	cdf_output.close_record(); in_book = false;
	cdf_output.close();
}

void output_end_bible_books()
{
	if (in_book)
		output_end_book();
}

void output_start_book(const char *name)
{
	if (in_book)
		output_end_book();

	char filename[100];
	sprintf(filename, "out\\book_%stxt", name);
	cdf_output.open(fopen(filename, "wt"));

	cdf_output.open_record("book");
	cdf_output.record_element("name");
	cdf_output.write_string(name);
	in_book = true;
}

void output_pericoop(CVerseRange &verse_range, const char *first_line, const char *rest)
{
	if (in_col) { cdf_output.close_list(); in_col = false; }
	if (in_verse) { cdf_output.close_record(); in_verse = false; }
	cdf_output.open_compact_record("pericoop");
	cdf_output.record_element("r");
	cdf_output.write_string(verse_range.str());
	cdf_output.record_element("f");
	cdf_output.write_string(first_line);
	cdf_output.record_element("m");
	cdf_output.write_string(rest);
	cdf_output.close_record();
}

void output_start_verse(CVerseNr &verse_nr)
{
	if (in_col) { cdf_output.close_list(); in_col = false; }
	if (in_verse) { cdf_output.close_record(); in_verse = false; }
	cdf_output.open_record("verse");
	in_verse = true;
	cdf_output.record_element("nr");
	char verse[200], *s = verse;
	verse_nr.print(s);
	cdf_output.write_string(verse);
}

void output_start_col1()
{
	cdf_output.record_element("greek");
	cdf_output.open_list();
	in_col = true;
}

void output_start_word_group()
{
	cdf_output.open_list("word_group");
}

void output_word_group_translation(const char *tr)
{
	cdf_output.open_compact_record("transl");
	cdf_output.write_string(tr);
	cdf_output.close_record();
}
	
void output_end_word_group()
{
	cdf_output.close_list();
}


/*********\
void output_tc_open_del(int nr)
{
	cdf_output.open_compact_record("tc_open_del");
	cdf_output.write_number(nr);
	cdf_output.close_record();
}

void outpur_tc_close_del(int nr)
{
	cdf_output.open_compact_record("tc_close_del");
	cdf_output.write_number(nr);
	cdf_output.close_record();
}

void output_tc_open_ins(int nr, char letter)
{
	cdf_output.open_compact_record("tc_open_ins");
	cdf_output.record_element("nr");
	cdf_output.write_number(nr);
	cdf_output.record_element("alt");
	cdf_output.write_char(letter);
	cdf_output.close_record();
}

void output_tc_ins_letter(int nr, char letter)
{
	cdf_output.open_compact_record("tc_open_ins");
	cdf_output.record_element("alt");
	cdf_output.write_char(letter);
	cdf_output.close_record();
}

void output_tc_close_ins(int nr)
{
	cdf_output.open_compact_record("tc_close_ins");
	cdf_output.write_number(nr);
	cdf_output.close_record();
}

void output_word_found()
{
	//fprintf(fout2, "output_word_found\n");
}
\*******/

void output_punctuation(char pun, CTextCritState::State &tc)
{
	cdf_output.open_compact_record("punct");
	cdf_output.record_element("letter");
	cdf_output.write_char(pun == (char)0xAF ? '|' : pun);
	char *tcdesc = tc.to_string();
	if (tcdesc[0] != '-' || tcdesc[1] != '\0')
	{	cdf_output.record_element("tc");
		cdf_output.write_string(tcdesc);
	}
	cdf_output.close_record();
}

void output_word(WordNumber *number, WordNumber *alt_number,
			     const char *greek, const char *transl, CTextCritState::State &tc)
{
	cdf_output.open_compact_record("word");
	cdf_output.record_element("number");
	cdf_output.open_list();
	cdf_output.write_string(number->word_form_str());
	if (alt_number)
		cdf_output.write_string(number->word_form_str());
	cdf_output.close_list();
	cdf_output.record_element("greek");
	cdf_output.open_record("G");
	cdf_output.write_raw_string(greek_to_output(greek));
	cdf_output.close_record();
	cdf_output.record_element("transl");
	cdf_output.write_string(transl);
	char *tcdesc = tc.to_string();
	if (tcdesc[0] != '-' || tcdesc[1] != '\0')
	{	cdf_output.record_element("tc");
		cdf_output.write_string(tcdesc);
	}
	cdf_output.close_record();
}

bool in_edition = false;
bool in_trans_edition = false;
bool in_greek_source = false;

void output_start_col2()
{
	if (in_col) { cdf_output.close_list(); in_col = false; }
	cdf_output.record_element("tc");
	cdf_output.open_list();
	in_col = true;
	in_edition = false;
	in_trans_edition = false;
	in_greek_source = false;
}

void output_tc_nr(word nr)
{
	cdf_output.record_element("nr");
	cdf_output.write_number(nr);
}

void output_tc_edition(char *edition, char mode = ' ')
{
	if (!in_edition)
	{	cdf_output.record_element("editions");
		cdf_output.open_compact_list();
		in_edition = true;
	}
	cdf_output.open_compact_record("ed");
	cdf_output.write_ident(edition);
	if (mode != ' ')
	{	cdf_output.record_element("mode");
		cdf_output.write_char(mode);
	}
	cdf_output.close_record();
}

void output_tc_trans_edition(char *edition, char mode)
{
	if (in_edition)
	{	cdf_output.close_list();
		in_edition = false;
	}
	if (!in_trans_edition)
	{	cdf_output.record_element("trans_editions");
		cdf_output.open_compact_list();
		in_trans_edition = true;
	}
	cdf_output.open_compact_record("ed");
	cdf_output.write_ident(edition);
	if (mode != ' ')
	{	cdf_output.record_element("mode");
		cdf_output.write_char(mode);
	}
	cdf_output.close_record();
}

void output_tc_greek_source(const char *source, char mode, const char *correction)
{
	if (in_edition)
	{	cdf_output.close_list();
		in_edition = false;
	}
	if (in_trans_edition)
	{	cdf_output.close_list();
		in_trans_edition = false;
	}
	if (!in_greek_source)
	{	cdf_output.record_element("greek_source");
		cdf_output.open_compact_list();
		in_greek_source = true;
	}
	cdf_output.open_compact_record("src");
	cdf_output.write_string(source);
	if (mode != ' ')
	{	cdf_output.record_element("mode");
		cdf_output.write_char(mode);
	}
	if (correction != 0)
	{	cdf_output.record_element("corr");
		cdf_output.write_string(correction);
	}
	cdf_output.close_record();
}

void output_tc_text_open()
{
	cdf_output.open_record("text");
}
void output_tc_text_close()
{
	if (in_edition)
	{	cdf_output.close_list();
		in_edition = false;
	}
	if (in_trans_edition)
	{	cdf_output.close_list();
		in_trans_edition = false;
	}
	if (in_greek_source)
	{	cdf_output.close_list();
		in_greek_source = false;
	}
	cdf_output.close_record();
}

void output_tc_variant_open(char letter)
{
	cdf_output.open_record("variant");
	if (letter != ' ')
	{	cdf_output.record_element("letter");
		cdf_output.write_char(letter);
	}
}
void output_tc_variant_close()
{
	if (in_edition)
	{	cdf_output.close_list();
		in_edition = false;
	}
	if (in_trans_edition)
	{	cdf_output.close_list();
		in_trans_edition = false;
	}
	if (in_greek_source)
	{	cdf_output.close_list();
		in_greek_source = false;
	}
	cdf_output.close_record();
}

bool greek_in_tc_remark;

void output_tc_remark_open(const char *name = 0)
{
	cdf_output.open_compact_record(name ? name : "remark");
	greek_in_tc_remark = false;
}
void output_tc_remark_char(char ch, char font_family)
{
	if (font_family == 'G')
	{	if (!greek_in_tc_remark)
		{	cdf_output.open_record("G");
			greek_in_tc_remark = true;
		}
		char gbuf[2];
		gbuf[0] = ch;
		gbuf[1] = '\0';
		cdf_output.write_raw_string(greek_to_output(gbuf));
	}
	else
	{	if (greek_in_tc_remark)
		{	cdf_output.close_record();
			greek_in_tc_remark = false;
		}
		cdf_output.write_char(ch);
	}
}
void output_tc_remark_close()
{
	if (greek_in_tc_remark)
	{	cdf_output.close_record();
		greek_in_tc_remark = false;
	}
	cdf_output.close_record();
}

void output_start_col3()
{
	if (in_col) { cdf_output.close_list(); in_col = false; }
	cdf_output.record_element("transl");
	cdf_output.open_list();
	in_col = true;
}

void output_test()
{
	cdf_output.open_compact_record("test");
	cdf_output.close_record();
}

void output_translation(const char *edition, const char *text)
{
	cdf_output.open_compact_record("trans");
	cdf_output.record_element("ed");
	cdf_output.write_string(edition);
	cdf_output.record_element("text");
	cdf_output.write_string(text);
	cdf_output.close_record();
}

void output_start_col4()
{
	if (in_col) { cdf_output.close_list(); in_col = false; }
	cdf_output.record_element("com");
	cdf_output.open_list();
	in_col = true;
}


//---------------------------------------------------------

int output_wnr = 0;

bool in_ws = false;
bool in_ws_word;
bool in_ws_word_forms;
bool in_ws_word_verse_refs;
bool in_ws_word_verse_ref;
bool in_ws_word_verse_form_numbers;

void output_start_word_study_books()
{
	char fn[100];
	sprintf(fn, "out\\wss%03d.txt", output_wnr/100);
	cdf_output.open(fopen(fn, "wt"));
	cdf_output.open_list();
	in_ws = true;
	in_ws_word = false;
}

void output_ws_end_word()
{
	if (in_ws_word_forms)
		cdf_output.close_list();
	if (in_ws_word_verse_refs)
	{	if (in_ws_word_verse_ref)
		{
			if (in_ws_word_verse_form_numbers)
				cdf_output.close_list();
			cdf_output.close_record();
		}
		cdf_output.close_list();
	}
	cdf_output.close_list();
	in_ws_word = false;
}

void output_end_word_study_books()
{
	if (in_ws)
	{
		if (in_ws_word)
			output_ws_end_word();
		
		cdf_output.close_list();
		cdf_output.close();
		in_ws = false;
	}
}

void output_greek_word_number(int number, int romnumber)
{
	WordNumber wordnumber;
	wordnumber.word_nr = number;
	wordnumber.word_romnr = romnumber;
	cdf_output.write_string(wordnumber.word_str());
	//char numbertxt[20];
	//char *romnrs[4] = { "", "II", "III", "IV" };
	//if (number <= 4932)
	//	sprintf(numbertxt, "%d%s", number, romnrs[romnumber-1]);
	//else
	//	sprintf(numbertxt, "0%d%s", number - 4932, romnrs[romnumber-1]);
	//cdf_output.write_string(numbertxt);
}

void output_ws_word(int number, int romnumber, char* greek, char *transl, bool inTR)
{
	output_wnr++;
	if (output_wnr % 100 == 0)
	{
		output_end_word_study_books();
		output_start_word_study_books();
	}
	if (in_ws_word)
		output_ws_end_word();

	cdf_output.open_list("word_study");
	cdf_output.record_element("number");
	output_greek_word_number(number, romnumber);
	cdf_output.record_element("greek");
	cdf_output.write_raw_string(greek_to_output(greek));
	cdf_output.record_element("transl");
	cdf_output.write_string(transl);
	if (!inTR)
	{	cdf_output.record_element("not_in_TR");
		cdf_output.write_number(1);
	}

	in_ws_word = true;
	in_ws_word_forms = false;
	in_ws_word_verse_refs = false;
}

void output_ws_start_description()
{
	cdf_output.record_element("description");
	cdf_output.open_list();
}

void output_ws_end_description()
{
	cdf_output.close_list();
}

bool in_ws_word_form_grammars;

void output_ws_word_form_open(int number, int as_number, const char* greek,
						 const char* transl, const char *vert, int inTR)
{
	if (!in_ws_word_forms)
	{
		cdf_output.record_element("word_forms");
		cdf_output.open_list();
		in_ws_word_forms = true;
	}
	cdf_output.open_compact_record("word_form");
	cdf_output.record_element("number");
	cdf_output.write_number(number);
	if (as_number > 0)
	{	cdf_output.record_element("as");
		cdf_output.write_number(as_number);
	}
	cdf_output.record_element("greek");
	cdf_output.write_raw_string(greek_to_output(greek));
	cdf_output.record_element("transl");
	cdf_output.write_string(transl);
	cdf_output.record_element("vert");
	cdf_output.write_string(vert);
	if (!inTR)
	{
		cdf_output.record_element("not_in_TR");
		cdf_output.write_number(inTR);
	}
	in_ws_word_form_grammars = false;
}

void output_ws_word_form_grammar(char c, char emv, char mvo, bool aor, bool pass, bool med, char* vert)
{
	if (!in_ws_word_form_grammars)
	{
		cdf_output.record_element("grammar");
		cdf_output.open_list();
		in_ws_word_form_grammars = true;
	}
	cdf_output.open_compact_record();
	if (c != ' ')
	{	cdf_output.record_element("c");
		cdf_output.write_char(c);
	}
	if (emv == 'e')
	{	cdf_output.record_element("n");
		cdf_output.write_char('s');
	}
	if (emv == 'm')
	{	cdf_output.record_element("n");
		cdf_output.write_char('p');
	}
	if (mvo == 'm')
	{	cdf_output.record_element("g");
		cdf_output.write_char('m');
	}
	if (mvo == 'v')
	{	cdf_output.record_element("g");
		cdf_output.write_char('f');
	}
	if (mvo == 'o')
	{	cdf_output.record_element("g");
		cdf_output.write_char('n');
	}
	if (aor)
	{	cdf_output.record_element("aor");
		cdf_output.write_number(1);
	}
	if (pass)
	{	cdf_output.record_element("pass");
		cdf_output.write_number(1);
	}
	if (med)
	{	cdf_output.record_element("med");
		cdf_output.write_number(1);
	}
	cdf_output.record_element("vert");
	cdf_output.write_string(vert);
	cdf_output.close_record();
}

void output_ws_word_form_close()
{
	if (in_ws_word_form_grammars)
		cdf_output.close_list();
	cdf_output.close_record();
}



void output_ws_word_verse_ref(char* book, int chap_nr, int verse_nr, char person_letter)
{
	if (in_ws_word_forms)
	{
		cdf_output.close_list();
		in_ws_word_forms = false;
	}
	if (!in_ws_word_verse_refs)
	{
		cdf_output.record_element("verse_refs");
		cdf_output.open_list();
		in_ws_word_verse_refs = true;
		in_ws_word_verse_ref = false;
	}
	if (in_ws_word_verse_ref)
		cdf_output.close_record();
	cdf_output.open_compact_record("verse_ref");
	cdf_output.record_element("verse");
	char versetext[30];
	if (chap_nr == 0)
		sprintf(versetext, "%s%d", book, verse_nr);
	else
		sprintf(versetext, "%s%d:%d", book, chap_nr, verse_nr);
	cdf_output.write_string(versetext);
	if (person_letter != '\0' && person_letter != ' ')
	{	cdf_output.record_element("person_letter");
		cdf_output.write_char(person_letter);
	}
	in_ws_word_verse_ref = true;
	in_ws_word_verse_form_numbers = false;
}

void output_ws_verse_ref_text(char *text)
{
	if (*text == '\0')
		return;
		
	cdf_output.record_element("text");
	cdf_output.open_list();
	while (*text != '\0')
	{
		if (*text == '{')
		{	text++;
			cdf_output.open_compact_record("mark");
			while (*text != '\0' && *text != '}')
				cdf_output.write_char(*text++);
			if (*text == '}')
				text++;
			cdf_output.close_record();
		}
		else
			cdf_output.write_char(*text++);
	}
	cdf_output.close_list();
}

void output_ws_verse_ref_form_number(int form_number)
{
	if (!in_ws_word_verse_ref)
	{	fprintf(stderr, "output_ws_verse_ref_form_number\n");
		return;
	}

	if (!in_ws_word_verse_form_numbers)
	{
		cdf_output.record_element("form_numbers");
		cdf_output.open_compact_list();
		in_ws_word_verse_form_numbers = true;
	}
	cdf_output.write_number(form_number);
}

void output_ws_word_last_part(char tc_code)
{
	if (in_ws_word_verse_form_numbers)
	{	cdf_output.close_list();
		in_ws_word_verse_form_numbers = false;
	}
	
	if (tc_code != '\0' && tc_code != ' ')
	{	cdf_output.record_element("tc_code");
		cdf_output.write_char(tc_code);
	}
}




//---------------------------------------------------------

bool in_text_ref;
bool in_word_ref;

void output_comm_start_par()
{
	cdf_output.open_compact_list("par");
	in_text_ref = false;
	in_word_ref = false;
}

void output_comm_end_par()
{
	if (in_text_ref) { cdf_output.close_record(); in_text_ref = false; }
	if (in_word_ref) { cdf_output.close_record(); in_word_ref = false; }
	cdf_output.close_list();
}


void output_comm_char(char ch, char mode)
{
	cdf_output.write_char(ch, mode & 2, mode & (1<<5));
}

void output_comm_text(char *str, char *mode, int len)
{
	if (mode)
	{
		for (int i = 0; i < len; i++)
			cdf_output.write_char(str[i], mode[i] & 2, mode[i] & (1<<5));
	}
	else
		cdf_output.write_string_len(str, len);
}

void output_comm_separator(char ch)
{
	cdf_output.write_char(ch);
}

void output_comm_start_word_ref()
{
	if (in_text_ref) { cdf_output.close_record(); in_text_ref = false; }
	
	if (!in_word_ref)
	{	cdf_output.open_record("word_ref");
		in_word_ref = true;
	}
}

void output_comm_end_word_ref(int number, int romnumber)
{
	if (!in_word_ref)
		cdf_output.open_record("word_ref");
	cdf_output.record_element("ref");
	output_greek_word_number(number, romnumber);
	cdf_output.close_record();
	in_word_ref = false;
}

void output_comm_start_text_ref()
{
	if (in_word_ref) { cdf_output.close_record(); in_word_ref = false; }

	if (!in_text_ref)
	{	cdf_output.open_record("text_ref");
		in_text_ref = true;
	}
}

void output_comm_end_text_ref(char *book_name,
							  int chapter_nr1, int verse_nr1, char verse_l1,
							  int chapter_nr2, int verse_nr2, char verse_l2)
{
	if (!in_text_ref)
		cdf_output.open_record("text_ref");
	cdf_output.record_element("ref");
	char ref[100];
	char *s = ref;
	strcpy(s, book_name);
	s += strlen(s);
	if (chapter_nr1 == 0)
	{	if (verse_nr1 > 0)
		{	sprintf(s, "%d", verse_nr1);
			s += strlen(s);
			if (verse_l1 != '\0')
			{	sprintf(s, "%c", verse_l1);
				s++;
			}
			if (verse_nr2 > 0)
			{	sprintf(s, "-%d", verse_nr2);
				s += strlen(s);
				if (verse_l2 != '\0')
				{	sprintf(s, "%c", verse_l2);
					s++;
				}
			}
		}
	}
	else
	{
		sprintf(s, "%d", chapter_nr1);
		s += strlen(s);
		if (verse_nr1 > 0)
		{	sprintf(s, ":%d", verse_nr1);
			s += strlen(s);
			if (verse_l1 != '\0')
			{	sprintf(s, "%c", verse_l1);
				s++;
			}
		}
		if (chapter_nr2 == 0 && verse_nr2 > 0)
			chapter_nr2 = chapter_nr1;
		if (chapter_nr2 > 0)
		{
			sprintf(s, "-%d", chapter_nr2);
			s += strlen(s);
			if (verse_nr2 > 0)
			{	sprintf(s, ":%d", verse_nr2);
				s += strlen(s);
				if (verse_l2 != '\0')
				{	sprintf(s, "%c", verse_l2);
					s++;
				}
			}
		}
	}
	cdf_output.write_string(ref);
	cdf_output.close_record();
	in_text_ref = false;
}


//---------------------------------------------------------

bool in_indexes = false;
bool in_index_entry;
bool in_index_entry_text;
bool in_index_entry_mark;
bool in_index_entry_elems;
void output_index_entry_text_close();
void output_index_entry_close();

void output_start_indexes()
{
	output_end_word_study_books();
	
	cdf_output.open(fopen("out\\indexes.txt", "wt"));
	cdf_output.open_list();
	in_indexes = true;
	in_index_entry = false;
}

void output_end_indexes()
{
	if (in_indexes)
	{
		if (in_index_entry)
			output_index_entry_close();		

		cdf_output.close_list();
		cdf_output.close();
		in_indexes = false;
	}
}

void output_index_entry_open()
{
	if (in_index_entry)
		output_index_entry_close();		

	cdf_output.open_compact_record("entry");
	in_index_entry = true;
	in_index_entry_text = false;
	in_index_entry_mark = false;
	in_index_entry_elems = false;
}

void output_index_entry_close()
{
	output_index_entry_text_close();
	if (in_index_entry_elems)
		cdf_output.close_list();
	cdf_output.close_record();
	in_index_entry = false;
}


void output_index_entry_text_char(char ch, bool mark)
{
	if (!in_index_entry_text)
	{
		cdf_output.record_element("text");
		cdf_output.open_compact_list();
		in_index_entry_text = true;
	}
	if (mark && !in_index_entry_mark)
	{
		cdf_output.open_compact_record("mark");
		in_index_entry_mark = true;
	}
	else if (in_index_entry_mark && !mark)
	{
		cdf_output.close_record();
		in_index_entry_mark = false;
	}
	cdf_output.write_char(ch);
}

void output_index_entry_text_close()
{
	if (in_index_entry_text)
	{
		if (in_index_entry_mark)
			cdf_output.close_record();
		cdf_output.close_list();
		in_index_entry_text = false;
	}
}

void output_index_entry_elem_open()
{
	
	if (!in_index_entry_elems)
	{
		cdf_output.open_list();
		in_index_entry_elems = true;
	}
	cdf_output.open_record("elem");
}
void output_index_entry_elem_only_SV()
{
	cdf_output.record_element("only_SV");
	cdf_output.write_number(1);
}

void output_index_entry_elem_part_of()
{
	cdf_output.record_element("part_of");
	cdf_output.write_number(1);
}

void output_index_entry_elem_indirect()
{
	cdf_output.record_element("indirect");
	cdf_output.write_number(1);
}

void output_index_entry_elem_greek(char *s)
{
	cdf_output.record_element("greek");
	cdf_output.write_string(s);
}

void output_index_entry_elem_number(char *s)
{
	cdf_output.record_element("number");
	cdf_output.write_string(s);
}

void output_index_entry_elem_close()
{
	cdf_output.close_record();
}
