
FILE* frest = 0;
bool rest_bar = false;

void output_rest_open()
{
	frest = fopen("out\\rest.html", "wt");
	if (frest)
	{
		fprintf(frest,"<HTML><HEAD>\n");
		fprintf(frest,"<TITLE>Rest</TITLE>\n");
		fprintf(frest,"</HEAD><BODY>\n");
	}
}

void output_rest_close()
{
	if (frest)
	{
		fprintf(frest,"</BODY></HTML>\n");
		fclose(frest);
		frest = 0;
	}
}

void output_rest_bar()
{
	if (frest == 0 || rest_bar)
		return;
		
	fprintf(frest, "<P><HR></P>\n");
	rest_bar = true;
}

void output_rest(CTextOnFramesAccessor &text_acc)
{
	if (frest == 0)
		return;
		
	rest_bar = false;
	char prev_isspace = true;

	fprintf(frest, "<P>\n");
	
	bool now_in_bold = false;
	bool now_in_italic = false;
	bool now_in_greek = false;
	bool now_in_symbol = false;
	bool now_in_super = false;
	for (; text_acc.More() && !text_acc.is_newline; text_acc.Next())
	{
		bool in_bold = text_acc.mode & MODE_B;
		bool in_italic = text_acc.mode & MODE_I;
		bool in_greek = text_acc.font_family == 'G';
		bool in_symbol =    text_acc.font_family == 'S'
						 || text_acc.font_family == '1'
						 || text_acc.font_family == '2';
		bool in_super = text_acc.mode & MODE_S;
		
		if (   now_in_super 
		    && (   !in_super
		    	|| in_greek != now_in_greek
		    	|| in_symbol != now_in_symbol
		    	|| in_italic != now_in_italic
		    	|| in_bold != now_in_bold))
		{	fprintf(frest, "</SUP>");
			now_in_super = false;
		}
		if (   now_in_greek
		    && (   !in_greek
		    	|| in_symbol != now_in_symbol
		    	|| in_italic != now_in_italic
				|| in_bold != now_in_bold))
		{	fprintf(frest, "</U>");
			now_in_greek = false;
		}
		if (   now_in_symbol
		    && (   !in_symbol
		    	|| in_italic != now_in_italic
				|| in_bold != now_in_bold))
		{	fprintf(frest, "</FONT>");
			now_in_symbol = false;
		}
		if (   now_in_italic
			&& (   !in_italic
		        || in_bold != now_in_bold))
		{	fprintf(frest, "</I>");
			now_in_italic = false;
		}
		if (   (now_in_bold && !in_bold))
		{	fprintf(frest, "</B>");
			now_in_bold = false;
		}
		if (in_bold && !now_in_bold)
		{	fprintf(frest, "<B>");
			now_in_bold = true;
		}
		if (in_italic && !now_in_italic)
		{	fprintf(frest, "<I>");
			now_in_italic = true;
		}
		if (in_greek && !now_in_greek)
		{	fprintf(frest, "<U>");
			now_in_greek = true;
		}
		if (in_symbol && !now_in_symbol)
		{	fprintf(frest, "<FONT COLOR=\"RED\">");
			now_in_symbol = true;
		}
		if (in_super && !now_in_super)
		{	fprintf(frest, "<SUP>");
			now_in_super = true;
		}
		if (text_acc.ch == '&')
			fprintf(frest, "&amp;");
		else if (text_acc.ch == '<')
			fprintf(frest, "&lt;");
		else if (text_acc.ch == '>')
			fprintf(frest, "&gt;");
		else if (text_acc.ch == '^' && prev_isspace)
			fprintf(frest, "-");
		else
			fprintf(frest, "%c", text_acc.ch);
		prev_isspace = isspace(text_acc.ch);
	}
	if (now_in_super)
	{	fprintf(frest, "</SUP>");
		now_in_super = false;
	}
	if (now_in_symbol)
	{	fprintf(frest, "</FONT>");
		now_in_symbol = false;
	}
	if (now_in_greek)
	{	fprintf(frest, "</U>");
		now_in_greek = false;
	}
	if (now_in_italic)
	{	fprintf(frest, "</I>");
		now_in_italic = false;
	}
	if (now_in_bold)
	{	fprintf(frest, "</B>");
		now_in_bold = false;
	}
	fprintf(frest, "</P>\n");
}

void output_rest(CFrameAccessor &frame_acc)
{
	if (frest == 0)
		return;
	
	CTextOnFramesAccessor text_acc(frame_acc);
	for (text_acc.Init(); text_acc.More(); text_acc.SkipLine())
		if (!text_acc.is_newline)
			output_rest(text_acc);
}

