#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include "stddef.c"
#define WIN32_LEAN_AND_MEAN
#define NOMINMAX
#include <windows.h>
#include "MMFile.cpp"
#include "CQXDoc.cpp"
#include "CBuf.cpp"
word dump_br = 0;
word echo_br = 0;
word dump = 0;
word echo = 0;
#include "CReadBuf.cpp"
#include "scanQXDoc.cpp"
#include "DumpQXDoc.cpp"
#include "FrameGeom.cpp"
#include "allfiles.h"


int main(int argc, char *argv[])
{
	_pa_file_len = 6000000;
	_pa_file_buf = NALLOC(_pa_file_len, byte);
	_pa_main_len = 5000000;
	_pa_main_buf = NALLOC(_pa_main_len, byte);
	_pa_other_len = 3000000;
	_pa_other_buf = NALLOC(_pa_other_len, byte);
	
	if (argc != 3)
	{
		printf("Usages: scan <nr-from> <nr-to>\n");
		printf("  (values should be from 0 to %d with ranges of about 100 per time)\n", nrfiles);
		return -1;
	}
	word from = atoi(argv[1]);
	word to = atoi(argv[2]);
	
	// Open a new database file
	if (!mmfile.Open("tmp/studybible.dat", 400000000))
		return 0;
	
	CDatabase *database = (CDatabase*)mmfile.FirstObject();
	if (from == 0 || database == NULL)
	{	
		mmfile.Reset();
		database = new CDatabase;
	}

    if (0)			
    {   int i;

		for (i = 0; i < 2048; i++)
			printf(" %d", (i /1000) % 10);
		printf("\n");
		for (i = 0; i < 2048; i++)
			printf(" %d", (i /100) % 10);
		printf("\n");
		for (i = 0; i < 2048; i++)
			printf(" %d", (i /10) % 10);
		printf("\n");
		for (i = 0; i < 2048; i++)
			printf(" %d", i % 10);
		printf("\n");
	}
	
	for (word i = from; i < nrfiles && i <= to; i++)
	{
		printf("\n%3d:%-26s ", i,thefiles[i]);
		echo_br = 0;
		dump_br = 0;
		echo = 0;
		dump = 0;
		char fn[200];
		sprintf(fn, "Q/%s", thefiles[i]);
	
		char book_name[8];
		strncpy(book_name, thefiles[i], 8);
		book_name[7] = '\0';
		if (book_name[6] == '/')
			book_name[6] = '\0';
			
		CBook *book = database->GetOrCreateBook(book_name);	
		
		CQXDoc *doc = book->AppendNewQXDoc(fn);
		
		scan_QX_doc(doc);

		AnalyzeFrameGeometry(doc);
			
		mmfile.Flush();
#ifdef DEBUG_MEM_ALLOC
		printf("\nAlloced space = %ld", alloced_space);
#endif

	}

	mmfile.Close();
	
	return 0;
}


